<ui:composition xmlns:rich="http://richfaces.org/rich" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">

    <ui:define name="body">
        <h:form id="globalForm">
            <h1>#{messages['gazelle.PAMSimulator.PatientIdentityCrossReferenceManager']}</h1>
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.PatientManager.ManageCrossreferences']}"
                                  rendered="#{crossReferencesManager.manageIdentities}"/>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.PatientManager.SendUpdateNotificationMessages']}"
                            rendered="#{not crossReferencesManager.manageIdentities}"/>
                </ui:define>
                <s:div rendered="#{crossReferencesManager.manageIdentities}">
                    <s:decorate template="/layout/form/_checkbox.xhtml">
                        <h:selectBooleanCheckbox id="sendUpdateBoolean"
                                                 value="#{crossReferencesManager.sendNotificationToSut}">
                            <a4j:ajax event="change" render="globalForm"/>
                        </h:selectBooleanCheckbox>
                        #{messages['gazelle.pam.SendUpdateNotifications']}
                        <h:outputText styleClass="help-block"
                                      value="#{messages['net.ihe.gazelle.PatientManager.IfYourSystemIsAPatientIdentificationConsumerWhic']}"/>
                    </s:decorate>
                    <div class="form-inline">
                        <s:decorate template="/layout/form/_edit.xhtml"
                                    rendered="#{crossReferencesManager.sendNotificationToSut}">
                            <ui:define name="label">#{messages['gazelle.pam.TransactionToBeUsed']}</ui:define>
                            <ui:param name="id" value="transactionInput"/>
                            <h:selectOneMenu styleClass="form-control" id="transactionInput"
                                             value="#{crossReferencesManager.selectedTransaction}">
                                <s:selectItems value="#{crossReferencesManager.transactions}"
                                               var="t" label="#{t.keyword} - #{t.name}"/>
                                <a4j:ajax event="change" render="globalForm"/>
                            </h:selectOneMenu>
                        </s:decorate>
                    </div>
                </s:div>
                <s:div rendered="#{crossReferencesManager.sendNotificationToSut}">
                    <f:subview id="hl7v2systemConfigPanel"
                               rendered="#{crossReferencesManager.selectedTransaction.keyword.equals('ITI-10')}">
                        <ui:include src="/configuration/initiatorFrame.xhtml">
                            <ui:param name="actorKeyword" value="PAT_IDENTITY_CONSUMER"/>
                            <ui:param name="diagramImg"
                                      value="diag/PAT_IDENTITY_X_REF_MGR_A31.png"/>
                            <ui:param name="currentConfig"
                                      value="#{crossReferencesManager.sut}"/>
                            <ui:param name="simuFacility"
                                      value="#{messages['gazelle.simulator.pam.IHE']}"/>
                            <ui:param name="simuApplication"
                                      value="#{messages['gazelle.patientmanager.PatientManager']}"/>
                            <ui:param name="sectionsToReRender" value="reportPanel"/>
                            <ui:param name="simulatorConfigurationName"
                                      value="#{messages['net.ihe.gazelle.PatientManager.PIXManager']}"/>
                            <ui:param name="availableSuts" value="#{crossReferencesManager.availableHL7v2Systems}"/>
                        </ui:include>
                        <br/>
                    </f:subview>
                    <f:subview id="systemConfigPanelITI46_2"
                               rendered="#{crossReferencesManager.selectedTransaction.keyword.equals('ITI-46')}">
                        <ui:include src="/hl7v3/sut/sutSelection.xhtml">
                            <ui:param name="senderDeviceId"
                                      value="#{iti46Manager.senderDeviceId}"/>
                            <ui:param name="organizationOid"
                                      value="#{iti46Manager.organizationOid}"/>
                            <ui:param name="sequenceDiagram"
                                      value="diag/PAT_IDENTITY_X_REF_MGR_V3.png"/>
                            <ui:param name="selectedSUT"
                                      value="#{iti46Manager.selectedSystem}"/>
                            <ui:param name="availableSystems"
                                      value="#{iti46Manager.availableSystems}"/>
                            <ui:param name="managedBean" value="#{iti46Manager}"/>
                        </ui:include>
                    </f:subview>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.PatientManager.ConfigureTheListOfDomainsForWhichYourSystemWillR']}"
                            style="font-weight:bold;"/>
                    <br/>
                    <rich:pickList
                            value="#{crossReferencesManager.selectedAuthorities}"
                            copyAllControlLabel="Add all" copyControlLabel="Add"
                            removeAllControlLabel="Remove all" removeControlLabel="Remove"
                            listWidth="200px">
                        <s:selectItems
                                value="#{crossReferencesManager.availableAuhorities}" var="hd"
                                label="#{hd.namespaceID} (#{hd.universalID})"/>
                        <s:convertEntity/>
                    </rich:pickList>
                </s:div>
                <s:div id="globalDiv">
                    <!-- parameters: messageBean: the name of the managed-bean which extends AbstractHL7MessagManager -->
                    <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
                    <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                                   value="#{crossReferencesManager.filter.urlParameters}"/>
                    <script>
                        updateUrl("globalForm:filterUrlParameters");
                        Event
                                .observe(
                                "globalForm:filterUrlParameters",
                                'change',
                                function () {
                                    updateUrl("globalForm:filterUrlParameters");
                                });
                    </script>
                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                        <div class="row">
                            <div class="col-md-4">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{crossReferencesManager.filter}"/>
                                    <ui:param name="filterWidth" value="240"/>
                                    <ui:param name="filterId" value="creator"/>
                                    <ui:param name="filterName" value="#{messages['gazelle.simulator.pam.Creator']}"/>
                                    <ui:param name="filterForm" value="globalDiv"/>
                                </ui:include>
                            </div>
                            <div class="col-md-8">
                                <ui:include src="/filter/filterDate.xhtml">
                                    <ui:param name="filter" value="#{crossReferencesManager.filter}"/>
                                    <ui:param name="filterWidth" value="240"/>
                                    <ui:param name="filterId" value="date"/>
                                    <ui:param name="filterName"
                                              value="#{messages['gazelle.simulator.pam.CreationDate']}"/>
                                    <ui:param name="filterForm" value="globalDiv"/>
                                </ui:include>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="firstnameInput"/>
                                    <ui:define name="label">#{messages['gazelle.simulator.pam.FirstName']}</ui:define>
                                    <h:inputText value="#{crossReferencesManager.firstName}" id="firstnameInput"
                                                 styleClass="form-control">
                                        <a4j:ajax event="keyup" render="globalDiv"/>
                                    </h:inputText>
                                </s:decorate>
                            </div>
                            <div class="col-md-6">
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="lastnameInput"/>
                                    <ui:define name="label">#{messages['gazelle.simulator.pam.LastName']}</ui:define>
                                    <h:inputText value="#{crossReferencesManager.lastName}" id="lastnameInput"
                                                 styleClass="form-control">
                                        <a4j:ajax event="keyup" render="globalDiv"/>
                                    </h:inputText>
                                </s:decorate>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="motherInput"/>
                                    <ui:define name="label">
                                        #{messages['net.ihe.gazelle.PatientManager.MotherMaidenName']}
                                    </ui:define>
                                    <h:inputText value="#{crossReferencesManager.motherMaidenName}" id="motherInput"
                                                 styleClass="form-control">
                                        <a4j:ajax event="keyup" render="globalDiv"/>
                                    </h:inputText>
                                </s:decorate>
                            </div>
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{crossReferencesManager.filter}"/>
                                    <ui:param name="filterWidth" value="240"/>
                                    <ui:param name="filterId" value="genderCode"/>
                                    <ui:param name="filterName"
                                              value="#{messages['net.ihe.gazelle.PatientManager.Gendercode']})"/>
                                    <ui:param name="filterForm" value="globalDiv"/>
                                </ui:include>
                            </div>
                        </div>
                        <ui:define name="filter_buttons">
                            <a4j:commandLink title="#{messages['gazelle.pam.RefreshResults']}"
                                             render="globalDiv">
                                <span class="fa fa-refresh"/>
                            </a4j:commandLink>
                            <a4j:commandLink title="#{messages['net.ihe.gazelle.simulator.hl7.ResetCriteria']}"
                                             actionListener="#{crossReferencesManager.reset()}"
                                             render="globalDiv">
                                <span class="fa fa-times-circle"/>
                            </a4j:commandLink>
                        </ui:define>
                    </ui:decorate>
                    #{dataTableStateHolder.setDescendingOn('creationDate')}
                    <rich:dataTable value="#{crossReferencesManager.patients}" var="pat"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                    render="ds" id="patientsTable">
                        <ui:include src="/patient/patientColumns.xhtml">
                            <ui:param name="patient" value="#{pat}"/>
                        </ui:include>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.HL7Common.Action']}</ui:define>
                            <div class="gzl-never-wrap">
                                <a4j:commandLink actionListener="#{crossReferencesManager.setSelectedPatient(pat)}"
                                                 title="#{messages['net.ihe.gazelle.PatientManager.DisplayPatientsInformation']}"
                                                 render="selectedPatientGrid, reportPanel">
                                    <s:span styleClass="gzl-icon-search"/>
                                </a4j:commandLink>
                                <a4j:commandLink
                                        actionListener="#{crossReferencesManager.sendUpdateNotification(pat)}"
                                        render="reportPanel"
                                        rendered="#{not crossReferencesManager.manageIdentities}"
                                        title="#{messages['net.ihe.gazelle.PatientManager.SendNotificationUpdateForThisPatient']}">
                                    <s:span styleClass="gzl-icon-paper-plane"/>
                                </a4j:commandLink>
                                <a4j:commandLink actionListener="#{crossReferencesManager.referencePatient(pat)}"
                                                 rendered="#{crossReferencesManager.manageIdentities}"
                                                 render="globalDiv"
                                                 title="#{messages['gazelle.pam.AddACrossReferenceToThisPatient']}">
                                    <s:span styleClass="gzl-icon-link"/>
                                </a4j:commandLink>
                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="patientsTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                    <s:div id="selectedPatientGrid">
                        <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                                    rendered="#{crossReferencesManager.selectedPatient != null}">
                            <ui:define name="panel_title">#{messages['gazelle.simulator.pam.SelectedPatient']}
                            </ui:define>
                            <div class="row">
                                <div class="col-md-6">
                                    <dl class="dl-horizontal">
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.simulator.pam.FirstName']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{crossReferencesManager.selectedPatient.firstName}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.simulator.pam.LastName']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{crossReferencesManager.selectedPatient.lastName}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">
                                                #{messages['gazelle.simulator.pam.MothersMaidenName']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{crossReferencesManager.selectedPatient.motherMaidenName}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">
                                                #{messages['gazelle.simulator.PatientGeneration.Gender']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{crossReferencesManager.selectedPatient.genderCode}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">
                                                #{messages['net.ihe.gazelle.PatientManager.DateOfBirth']}
                                            </ui:define>
                                            <g:date
                                                    value="#{crossReferencesManager.selectedPatient.dateOfBirth}"
                                                    time="false"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">
                                                #{messages['net.ihe.gazelle.PatientManager.Identifiers']}
                                            </ui:define>
                                            <rich:list
                                                    rendered="#{crossReferencesManager.selectedPatient.patientIdentifiers != null}"
                                                    value="#{crossReferencesManager.selectedPatient.patientIdentifiers}"
                                                    var="pid">
                                                <h:outputText value="#{pid.fullPatientId}"/>
                                            </rich:list>
                                        </s:decorate>
                                    </dl>
                                </div>
                                <div class="col-md-6">
                                    <h:outputText
                                            value="#{messages['net.ihe.gazelle.PatientManager.TheSelectedPatientIsReferencedWithThePatientsBel']}"
                                            styleClass="help-block"/>
                                    <a4j:repeat value="#{crossReferencesManager.selectedReference.patients}"
                                                var="xpat"
                                            rendered="#{crossReferencesManager.selectedReference != null and not empty crossReferencesManager.selectedReference.patients}">
                                        <div class="gzl-never-wrap">
                                            <h:outputLink value="#{xpat.getPermanentLink()}"
                                                          title="#{messages['gazelle.pam.ClickToOpenDetails']}">
                                                <h:outputText
                                                        value="#{xpat.firstName} #{xpat.lastName} (#{xpat.genderCode})"/>
                                            </h:outputLink>
                                            <a4j:commandLink
                                                    actionListener="#{crossReferencesManager.removePatientFromSet(xpat)}"
                                                    oncomplete="jq162('#panelForNotification').modal('show')"
                                                    render="globalDiv">
                                                <s:span styleClass="gzl-icon-trash-o"/>
                                            </a4j:commandLink>
                                        </div>
                                        <rich:list value="#{xpat.patientIdentifiers}" var="xpid"
                                                   type="unordered">
                                            <h:outputText value="#{xpid.fullPatientId}"/>
                                        </rich:list>
                                    </a4j:repeat>
                                </div>
                            </div>
                            <ui:define name="panel_footer">
                                <a4j:commandButton styleClass="gzl-btn"
                                                   value="#{messages['gazelle.pam.ChooseAnotherPatient']}"
                                                   actionListener="#{crossReferencesManager.resetPatientChoice()}"
                                                   render="globalDiv"/>

                            </ui:define>
                        </s:decorate>
                    </s:div>
                    <s:decorate template="/layout/panels/_panel_title_footer_id.xhtml"
                                rendered="#{crossReferencesManager.hl7Messages != null}">
                        <ui:param name="panel_id" value="reportPanel"/>
                        <ui:define name="panel_title">#{messages['gazelle.simulator.pam.TestReport']}</ui:define>
                        <ui:include src="/messages/message_table.xhtml">
                            <ui:param name="hl7Messages" value="#{crossReferencesManager.hl7Messages}"/>
                        </ui:include>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['gazelle.simulator.pam.PerformAnotherTest']}"
                                               styleClass="gzl-btn-blue"
                                               render="globalForm"
                                               actionListener="#{crossReferencesManager.performAnotherTest()}"/>
                        </ui:define>
                    </s:decorate>
                </s:div>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>